       IDENTIFICATION      DIVISION.
       PROGRAM-ID.     SAMPLEB.
      ******************************************************************
      * PANDA -- a simple transaction monitor
      *
      * Copyright (C) 2000-2002 Ogochan & JMA (Japan Medical Association).
      *
      * This module is part of PANDA.
      *
      *     PANDA is distributed in the hope that it will be useful, but
      * WITHOUT ANY WARRANTY.  No author or distributor accepts 
      * responsibility to anyone for the consequences of using it or for
      * whether it serves any particular purpose or works at all, unless
      * he says so in writing.
      * Refer to the GNU General Public License for full details. 
      *
      *     Everyone is granted permission to copy, modify and
      * redistribute PANDA, but only under the conditions described in
      * the GNU General Public License.  A copy of this license is
      * supposed to have been given to you along with PANDA so you can
      * know your rights and responsibilities.  It should be in a file
      * named COPYING.  Among other things, the copyright notice and 
      * this notice must be preserved on all copies. 
      ******************************************************************
      *   ƥ̾      PANDA TP˥
      *   ֥ƥ̾  ǥ
      *   ݡͥ̾Хåץ
      *             ogochan@NetLab.jp
      *     ȼ  
      *   01.05.28  ....    
      ******************************************************************
       ENVIRONMENT         DIVISION.
       CONFIGURATION           SECTION.
       SPECIAL-NAMES.
      *     CONSOLE         IS  CONSOLE.
       INPUT-OUTPUT            SECTION.
       FILE-CONTROL.
           SELECT  LOG-FILE
               ASSIGN  TO  "log"
               ORGANIZATION    SEQUENTIAL
               ACCESS  MODE    SEQUENTIAL.
       DATA                DIVISION.
       FILE                    SECTION.
       FD  LOG-FILE.
       01  LOG-REC.
           02  LOG-DATA    PIC X(127).
           02  LOG-CR      PIC X.
       WORKING-STORAGE         SECTION.
       01  FLG.
           02  FLG-EOF     PIC 9.
       01  WRK.
           02  WRK-BUFF    PIC X(30).
       01  I           PIC S9(9)   BINARY.
      *
       01  EDT.
           02  EDT-1.
             03  EDT-NAME    PIC X(20).
             03  FILLER          PIC X       VALUE  ':'.
             03  EDT-TEL     PIC X(13).
             03  FILLER          PIC X       VALUE  ':'.
             03  EDT-TOLL    PIC ZZZ9.9.
           02  EDT-2.
             03  EDT-ADDRESS1    PIC X(20).
             03  FILLER          PIC X       VALUE  ':'.
             03  EDT-ADDRESS2    PIC X(20).
             03  FILLER          PIC X       VALUE  ':'.
             03  EDT-ADDRESS3    PIC X(20).
      *
       COPY    DBPATH.
       COPY    DB-META.
       COPY    DB-ADRS.
       COPY    MCPAREA.
       LINKAGE                 SECTION.
       01  PARA.
           02  FILLER      PIC X(256).
      ******************************************************************
       PROCEDURE           DIVISION
               USING
           PARA.
       000-MAIN                SECTION.
           DISPLAY    '*** SAMPLEB'
               UPON    CONSOLE.
      *
           PERFORM 010-INIT.
           PERFORM 200-DELETE.
           PERFORM 090-FINISH.
      *
           STOP    RUN.
      ******************************************************************
       010-INIT                SECTION.
           OPEN    OUTPUT
               LOG-FILE.
           PERFORM 800-DBOPEN.
           PERFORM 800-DBSTART.
      ******************************************************************
       090-FINISH              SECTION.
           PERFORM 800-DBCOMMIT.
           PERFORM 800-DBDISCONNECT.
      *
           CLOSE
               LOG-FILE.
      ******************************************************************
       200-DELETE              SECTION.
           PERFORM VARYING I   FROM    1   BY  1
                   UNTIL   (  I   >  100  )
               MOVE   I                TO  ADR-NAME
      *
               MOVE   'DBDELETE'   TO  MCP-FUNC
               MOVE    PATH-ADRS-MAIL  TO  MCP-PATH
               CALL   'MCPSUB'     USING
                    MCPAREA
                    ADRS
           END-PERFORM.
      ******************************************************************
       800-DBOPEN              SECTION.
           MOVE   'DBOPEN'     TO  MCP-FUNC.
      *
           CALL   'MCPSUB'     USING
                MCPAREA
                METADB.
      ******************************************************************
       800-DBSTART             SECTION.
           MOVE   'DBSTART'    TO  MCP-FUNC.
      *
           CALL   'MCPSUB'     USING
                MCPAREA
                METADB.
      ******************************************************************
       800-DBCOMMIT            SECTION.
           MOVE   'DBCOMMIT'   TO  MCP-FUNC.
      *
           CALL   'MCPSUB'     USING
                MCPAREA
                METADB.
      ******************************************************************
       800-DBDISCONNECT        SECTION.
           MOVE   'DBDISCONNECT'    TO  MCP-FUNC.
      *
           CALL   'MCPSUB'     USING
                MCPAREA
                METADB.
